Index: branches/water/src/story_entities/game_world.cc
===================================================================
--- branches/water/src/story_entities/game_world.cc	(revision 8263)
+++ branches/water/src/story_entities/game_world.cc	(revision 8268)
@@ -112,29 +112,29 @@
 void GameWorld::enterGui()
 {
-  OrxGui::GLGuiBox* imageSelector = new OrxGui::GLGuiBox();
-  {
-    image = new OrxGui::GLGuiImage();
-    image->setWidgetSize(300, 300);
-    image->setAbsCoor2D(300, 300);
-    imageSelector->pack(image);
-
-    imageName = new OrxGui::GLGuiInputLine();
-    imageSelector->pack(imageName);
-
-    OrxGui::GLGuiSlider* slider = new OrxGui::GLGuiSlider();
-    slider->setWidgetSize(200, 30);
-    slider->setRange(0, 200);
-    slider->setStep(1);
-    
-    
-    slider->setValue(slider->min());
-    slider->connect(SIGNAL(slider, valueChanged), this, SLOT(GameWorld, setImage));
-
-    imageSelector->pack(slider);
-    slider->setValue(getImage("/home/stefalie/svn/orxonox/data/trunk/pictures/refl.bmp"));
-  }
-  imageSelector->showAll();
-  imageSelector->setAbsCoor2D(200, 200);
-    OrxGui::GLGuiHandler::getInstance()->activateCursor();
+//   OrxGui::GLGuiBox* imageSelector = new OrxGui::GLGuiBox();
+//   {
+//     image = new OrxGui::GLGuiImage();
+//     image->setWidgetSize(300, 300);
+//     image->setAbsCoor2D(300, 300);
+//     imageSelector->pack(image);
+// 
+//     imageName = new OrxGui::GLGuiInputLine();
+//     imageSelector->pack(imageName);
+// 
+//     OrxGui::GLGuiSlider* slider = new OrxGui::GLGuiSlider();
+//     slider->setWidgetSize(200, 30);
+//     slider->setRange(0, 200);
+//     slider->setStep(1);
+//     
+//     
+//     slider->setValue(slider->min());
+//     slider->connect(SIGNAL(slider, valueChanged), this, SLOT(GameWorld, setImage));
+// 
+//     imageSelector->pack(slider);
+//     slider->setValue(getImage("/home/stefalie/svn/orxonox/data/trunk/pictures/refl.bmp"));
+//   }
+//   imageSelector->showAll();
+//   imageSelector->setAbsCoor2D(200, 200);
+//     OrxGui::GLGuiHandler::getInstance()->activateCursor();
 
   /////
Index: branches/water/src/world_entities/environments/mapped_water.cc
===================================================================
--- branches/water/src/world_entities/environments/mapped_water.cc	(revision 8263)
+++ branches/water/src/world_entities/environments/mapped_water.cc	(revision 8268)
@@ -125,5 +125,5 @@
   Shader::Uniform(shader, "dudvMap").set(3);
   // Set the variable "depthMap" to correspond to the fifth texture unit
-  //Shader::Uniform(shader, "depthMap").set(4);
+  Shader::Uniform(shader, "depthMap").set(2);
   // Give the variable "waterColor" a blue color
   Shader::Uniform(shader, "waterColor").set(0.1f, 0.2f, 0.4f, 1.0f);
@@ -173,5 +173,5 @@
   glMultiTexCoord2f(GL_TEXTURE2, 0.0f, normalUV + move2);     // Normal map texture
   glMultiTexCoord2f(GL_TEXTURE3, 0, 0);                       // DUDV map texture
-  glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                       // Depth texture
+  //glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                       // Depth texture
   glVertex3f(0.0f, waterHeight, 0.0f);
 
@@ -183,5 +183,5 @@
   glMultiTexCoord2f(GL_TEXTURE2, 0.0f, 0.0f + move2);          // Normal map texture
   glMultiTexCoord2f(GL_TEXTURE3, 0, 0);                        // DUDV map texture
-  glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                        // Depth texture
+  //glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                        // Depth texture
   glVertex3f(0.0f, waterHeight, 1000.0f);
 
@@ -193,5 +193,5 @@
   glMultiTexCoord2f(GL_TEXTURE2, normalUV, 0.0f + move2);      // Normal map texture
   glMultiTexCoord2f(GL_TEXTURE3, 0, 0);                        // DUDV map texture
-  glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                        // Depth texture
+  //glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                        // Depth texture
   glVertex3f(1000.0f, waterHeight, 1000.0f);
 
@@ -203,5 +203,5 @@
   glMultiTexCoord2f(GL_TEXTURE2, normalUV, normalUV + move2);  // Normal map texture
   glMultiTexCoord2f(GL_TEXTURE3, 0, 0);                        // DUDV map texture
-  glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                        // Depth texture
+  //glMultiTexCoord2f(GL_TEXTURE4, 0, 0);                        // Depth texture
   glVertex3f(1000.0f, waterHeight, 0.0f);
   glEnd();
@@ -269,5 +269,5 @@
 void MappedWater::deactivateReflection()
 {
-  //glDisable(GL_CLIP_PLANE0);
+  glDisable(GL_CLIP_PLANE0);
   glCullFace(GL_BACK);
 
@@ -288,5 +288,5 @@
 
 void MappedWater::activateRefraction()
-{ 
+{/*
   // save viewport matrix and change the viewport size
   glPushAttrib(GL_VIEWPORT_BIT);
@@ -299,5 +299,5 @@
   // In order to line up the reflection nicely with the world we have to translate
   // the world to the position of our reflected surface, multiplied by two.
-  //glEnable(GL_CLIP_PLANE0);
+  glEnable(GL_CLIP_PLANE0);
   Vector pos = State::getCameraNode()->getAbsCoor();
   //pos.debug();
@@ -314,5 +314,5 @@
     // Set our plane equation and turn clipping on
     double plane[4] = {0.0, 1.0, 0.0, -waterHeight};
-    //glClipPlane(GL_CLIP_PLANE0, plane);
+    glClipPlane(GL_CLIP_PLANE0, plane);
   }
   else
@@ -321,8 +321,8 @@
     // but just render it clipped so only the top is drawn.
     double plane[4] = {0.0, 1.0, 0.0, waterHeight};
-    //glClipPlane(GL_CLIP_PLANE0, plane);
-  }
-
-/*
+    glClipPlane(GL_CLIP_PLANE0, plane);
+  }
+*/
+
   // To create the refraction and depth textures we do the same thing
   // we did for the reflection texture, except we don't need to turn
@@ -343,5 +343,5 @@
 
   // If the camera is above water, render the data below the water
-  glEnable(GL_CLIP_PLANE1);
+  glEnable(GL_CLIP_PLANE0);
   Vector pos = State::getCameraNode()->getAbsCoor();
   if(pos.y > waterHeight)
@@ -358,10 +358,9 @@
     glClipPlane(GL_CLIP_PLANE0, plane);
   }
-  PRINTF(0)("test");*/
 }
 
 void MappedWater::deactivateRefraction()
 {
-  //glDisable(GL_CLIP_PLANE0);
+  glDisable(GL_CLIP_PLANE0);
   glCullFace(GL_BACK);
 