Index: branches/bsp_model/src/lib/collision_reaction/collision_handle.cc
===================================================================
--- branches/bsp_model/src/lib/collision_reaction/collision_handle.cc	(revision 8287)
+++ branches/bsp_model/src/lib/collision_reaction/collision_handle.cc	(revision 8288)
@@ -204,11 +204,12 @@
   }
 
+  // if continuous poll poll the reaction
+  if( this->bContinuousPoll && this->bCollided)
+    this->collisionReaction->update(this->owner);
+
   // now set state to dispatched
   this->bDispatched = true;
   this->bCollided = false;
 
-  // if continuous poll poll the reaction
-   if( this->bContinuousPoll)
-     this->collisionReaction->update(this->owner);
   this->flushCollisions();
 }
@@ -232,5 +233,4 @@
   }
 
-
   return false;
 }
Index: branches/bsp_model/src/lib/collision_reaction/cr_object_damage.cc
===================================================================
--- branches/bsp_model/src/lib/collision_reaction/cr_object_damage.cc	(revision 8287)
+++ branches/bsp_model/src/lib/collision_reaction/cr_object_damage.cc	(revision 8288)
@@ -54,5 +54,5 @@
   float damage = 0.0f;
 
-  PRINTF(0)("Dealing damage - Handling collision: %s vs %s\n",
+  PRINTF(4)("Dealing damage - Handling collision: %s vs %s\n",
             collision->getEntityA()->getClassName(),
             collision->getEntityB()->getClassName());
@@ -63,5 +63,5 @@
     collision->getEntityA()->decreaseHealth(damage);
   }
-  PRINTF(0)("Dealing damage - %f damage to %s \n", damage, collision->getEntityA()->getClassName());
+  PRINTF(4)("Dealing damage - %f damage to %s \n", damage, collision->getEntityA()->getClassName());
 
   if( collision->isEntityBCollide()) {
@@ -69,5 +69,5 @@
     collision->getEntityB()->decreaseHealth(damage);
   }
-  PRINTF(0)("Dealing damage - %f damage to %s \n", damage, collision->getEntityB()->getClassName());
+  PRINTF(4)("Dealing damage - %f damage to %s \n", damage, collision->getEntityB()->getClassName());
 
   collision->flushCollisionEvents();
Index: branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc
===================================================================
--- branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8287)
+++ branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8288)
@@ -23,4 +23,6 @@
 #include "world_entity.h"
 #include "cr_physics_ground_walk.h"
+
+#include <vector>
 
 using namespace std;
@@ -51,6 +53,16 @@
 void CRPhysicsGroundWalk::reactToCollision(Collision* collision)
 {
-//   Vector normal = collision
-  PRINTF(0)("Ground\n");
+  CollisionEvent* ce = collision->getCollisionEvents().front();
+  Vector normal = ce->getGroundNormal();
+  normal.normalize();
+
+  // put it back
+  PRINTF(0)("putting it back\n");
+  collision->getEntityB()->setVelocity(Vector());
+//  collision->getEntityB()->setAbsCoorSoft(this->lastPosition, 0.1);
+//   collision->getEntityB()->setAbsCoor(this->lastPosition/* + normal * (-5.0f)*/);
+
+
+
 }
 
@@ -64,6 +76,4 @@
   this->lastPosition = owner->getAbsCoor();
   this->lastDirection = owner->getAbsDir();
-
-
 }
 
Index: branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc
===================================================================
--- branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc	(revision 8287)
+++ branches/bsp_model/src/lib/graphics/importer/bsp_manager.cc	(revision 8288)
@@ -918,5 +918,5 @@
     */
 
-    float height = 10;
+    float height = 40;
 
 
Index: branches/bsp_model/src/world_entities/space_ships/turbine_hover.h
===================================================================
--- branches/bsp_model/src/world_entities/space_ships/turbine_hover.h	(revision 8287)
+++ branches/bsp_model/src/world_entities/space_ships/turbine_hover.h	(revision 8288)
@@ -59,5 +59,5 @@
     float                 rotation;
 
-    Vector                velocity;           //!< the velocity of the TurbineHover.
+   // Vector                velocity;           //!< the velocity of the TurbineHover.
     Quaternion            direction;          //!< the direction of the TurbineHover.
     float                 travelSpeed;        //!< the current speed of the Hove (to make soft movement)
Index: branches/bsp_model/src/world_entities/world_entity.h
===================================================================
--- branches/bsp_model/src/world_entities/world_entity.h	(revision 8287)
+++ branches/bsp_model/src/world_entities/world_entity.h	(revision 8288)
@@ -137,4 +137,5 @@
   inline float getMass() const { return this->physicsInterface.getMass(); }
   inline float getTotalMass() const { return this->physicsInterface.getTotalMass(); }
+  inline void setVelocity(const Vector& vel) { this->velocity = vel; }
 
 
@@ -186,4 +187,8 @@
   PhysicsInterface        physicsInterface;                //!< the physics object of the WorldEntity
 
+
+  protected:
+  Vector                  velocity;                        //!< speed of the entity
+
 };
 